﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Azyobuzi.りすにんぐついったー 
{
    class WmpListener :IMusicDataListener
    {
        MsnCommandListener msnCommandListener;

        public WmpListener() 
        {
            this.msnCommandListener = new MsnCommandListener();
            this.msnCommandListener.ReceiveMsnCommand += (e) => {
                if (this.ListeningMusicChanged != null) {
                    var musicData = new[] { "", "", "" };
                    for (int i = 0; i < musicData.Length; i++) {
                        if (e.Datas.Length > i) {
                            musicData[i] = e.Datas[i];
                        }
                    }
                    ListeningMusicChangedEventArgs args = null;
                    if (!string.IsNullOrWhiteSpace(musicData[0]) || !string.IsNullOrWhiteSpace(musicData[1]) || !string.IsNullOrWhiteSpace(musicData[2]))
                    {
                        args = new ListeningMusicChangedEventArgs(musicData[0], musicData[1], musicData[2]);
                    }
                    ListeningMusicChanged(this, args);
                }
            };
        }

        public event EventHandler<ListeningMusicChangedEventArgs> ListeningMusicChanged;

        public bool Enable 
        {
            get {
                return this.msnCommandListener.Enable;
            }
            set {
                this.msnCommandListener.Enable = value;
            }
        }

        public void Start() {
            this.msnCommandListener.Start();
        }

        public void Stop() {
            this.msnCommandListener.Stop();
        }

        public void Dispose() {
            try {
                this.msnCommandListener.Stop();
            } catch (InvalidOperationException) { }
        }
    }
}
